
/*  A Bison parser, made from kasm_parser.yy
    by GNU Bison version 1.28  */

#define YYBISON 1  /* Identify Bison output.  */

#define	PTR	257
#define	ID	258
#define	LAM	259
#define	STRING	260
#define	CHR	261
#define	REAL	262
#define	EXREAL	263
#define	CMP	264
#define	EXCMP	265
#define	DOCOL	266
#define	SEMI	267
#define	SYMBOL	268
#define	UNIT	269
#define	MATRIX	270
#define	TAG	271
#define	ROMPTR	272
#define	FPTR	273
#define	ACPTR	274
#define	LENBODYOB	275
#define	NIBB	276
#define	NIBBHEX	277
#define	ZINT	278
#define	CODE	279
#define	ENDCODE	280
#define	LABEL	281
#define	DEFINE	282
#define	DCCP	283
#define	NAME	284
#define	NUMBER	285
#define	HEX_NUMBER	286
#define	HEX_REV_NUMBER	287
#define	MNEMADDSUB	288
#define	MNEMADDSUBCON	289
#define	MNEMZEROETAL	290
#define	MNEMLOGICAL	291
#define	MNEMSRB	292
#define	MNEMACLD	293
#define	MNEMMEMORY	294
#define	MNEMBIT	295
#define	MNEMDATREGADD	296
#define	MNEMDATREGLD	297
#define	MNEMPLD	298
#define	MNEMSCRATCHREG	299
#define	MNEMCPASN	300
#define	MNEMSETST	301
#define	MNEMGOTO	302
#define	MNEMGOTOC	303
#define	MNEMTEST1	304
#define	MNEMTEST2	305
#define	MNEMTEST3	306
#define	MNEMTEST4	307
#define	MNEMTEST5	308
#define	MNEMNOFIELD2	309
#define	MNEMNOFIELD3	310
#define	MNEMNOFIELD4	311
#define	MNEMNOFIELD5	312
#define	SKIP	313
#define	SKUB	314
#define	SKIPC	315
#define	SKIPNC	316
#define	SKIPL	317
#define	SKUBL	318
#define	SKIPYES	319
#define	EXIT	320
#define	UP	321
#define	EXITC	322
#define	UPC	323
#define	EXITNC	324
#define	UPNC	325
#define	STROBJ	326
#define	FIELD	327
#define	CON	328
#define	GOINAC	329
#define	GOINN	330
#define	CP	331
#define	GOYES	332
#define	RTNYES	333
#define	ARROW	334
#define	GE	335
#define	LE	336
#define	LSHIFT	337
#define	RSHIFT	338

#line 2 "kasm_parser.yy"

/* $Id: kasm_parser.yy,v 1.71 2001/03/13 13:13:44 ekalin Exp $ */

/*
 *   kasm: Assembler for the Saturn processor, used in HP48 and HP49
 *   graphical calculators.
 *   Copyright (C) 2001 Eduardo M Kalinowski (ekalin@iname.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <string>
#include <deque>
#include <map>
#include <stdio.h>

#include "entrytable.hpp"
#include "nib_io.hpp"
#include "kasm.hpp"


// File variables
static unsigned long constpointer = 0x80100;    // Used by DCCP
static long cpointerincr;                       // Used by : Inc ... :

// Global variables
bool use_reversed = false;

#line 48 "kasm_parser.yy"
typedef union {
  long number;
  char str[80];
  unsigned char chr;
} YYSTYPE;
#ifndef YYDEBUG
#define YYDEBUG 1
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		286
#define	YYFLAG		-32768
#define	YYNTBASE	105

#define YYTRANSLATE(x) ((unsigned)(x) <= 338 ? yytranslate[x] : 126)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,   100,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    81,     2,    84,    97,    94,    83,     2,   103,
   104,    92,    91,     2,    90,   101,    93,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,   102,     2,    87,
    85,    86,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,    82,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    98,     2,    99,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     3,     4,     5,     6,
     7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
    17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
    27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
    77,    78,    79,    80,    88,    89,    95,    96
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     7,    10,    13,    16,    19,    21,    24,
    26,    29,    32,    36,    40,    44,    48,    52,    56,    60,
    61,    66,    70,    74,    78,    82,    86,    89,    92,    96,
    99,   103,   107,   108,   111,   112,   115,   117,   120,   123,
   125,   128,   131,   135,   139,   144,   147,   151,   154,   158,
   161,   165,   168,   171,   175,   178,   182,   185,   189,   192,
   195,   198,   202,   205,   208,   212,   215,   219,   222,   225,
   228,   232,   235,   239,   242,   246,   248,   251,   255,   258,
   261,   263,   265,   267,   269,   271,   275,   279,   282,   284,
   286,   289,   292,   295,   299,   300,   306,   308,   310,   312,
   314,   316,   318,   322,   323,   329,   334,   335,   341,   342,
   348,   349,   355,   356,   362,   363,   369,   370,   376,   377,
   384,   386,   389,   391,   395,   399,   403,   407,   411,   415,
   419,   423,   427,   431,   435,   439,   443,   447,   451,   455,
   459,   461,   463,   465
};

static const short yyrhs[] = {   106,
     0,   108,   105,     0,    30,     0,    84,    30,     0,     3,
    30,     0,     4,     6,     0,     5,     6,     0,     6,     0,
    97,     6,     0,     7,     0,     8,    30,     0,     9,    30,
     0,    10,    30,    30,     0,    11,    30,    30,     0,    12,
   109,    13,     0,    98,   109,    99,     0,    14,   109,    13,
     0,    15,   109,    13,     0,    16,   109,    13,     0,     0,
    17,     6,   107,   105,     0,    18,    30,    30,     0,    19,
    30,    30,     0,    20,    30,    30,     0,    21,    30,    30,
     0,    22,    30,    30,     0,    23,    30,     0,    24,    30,
     0,    25,   110,    26,     0,    27,    30,     0,    28,    30,
    30,     0,    29,    30,    30,     0,     0,   109,   105,     0,
     0,   110,   111,     0,   100,     0,   112,   100,     0,     1,
   100,     0,   113,     0,   112,   113,     0,    34,    73,     0,
    34,   101,    73,     0,    35,   124,    73,     0,    35,   124,
   101,    73,     0,    36,    73,     0,    36,   101,    73,     0,
    37,    73,     0,    37,   101,    73,     0,    38,    73,     0,
    38,   101,    73,     0,    39,   124,     0,    40,    73,     0,
    40,   101,    73,     0,    40,   124,     0,    40,   101,   124,
     0,    41,   124,     0,    41,   101,   124,     0,    42,   124,
     0,    43,   124,     0,    45,    73,     0,    45,   101,    73,
     0,    44,   124,     0,    46,   124,     0,    46,   101,   124,
     0,    47,   124,     0,    47,   101,   124,     0,    48,   124,
     0,    49,   124,     0,    50,    73,     0,    50,   101,    73,
     0,    51,    73,     0,    51,   101,    73,     0,    52,   124,
     0,    52,   101,   124,     0,    53,     0,    54,   124,     0,
    54,   101,   124,     0,    78,   124,     0,    80,   124,     0,
    79,     0,    55,     0,    56,     0,    57,     0,    58,     0,
    28,    30,   124,     0,    28,    73,   124,     0,    74,   124,
     0,    32,     0,    33,     0,    75,   124,     0,    76,   124,
     0,    77,   124,     0,    29,   124,    30,     0,     0,   102,
   124,   114,   123,   102,     0,    66,     0,    67,     0,    68,
     0,    69,     0,    70,     0,    71,     0,    98,   110,    99,
     0,     0,    65,   115,    98,   110,    99,     0,    80,    98,
   110,    99,     0,     0,    59,    98,   116,   110,    99,     0,
     0,    60,    98,   117,   110,    99,     0,     0,    61,    98,
   118,   110,    99,     0,     0,    62,    98,   119,   110,    99,
     0,     0,    63,    98,   120,   110,    99,     0,     0,    64,
    98,   121,   110,    99,     0,     0,    72,   124,    98,   122,
   110,    99,     0,    30,     0,   123,    30,     0,   125,     0,
   124,    81,   124,     0,   124,    82,   124,     0,   124,    83,
   124,     0,   124,    84,   124,     0,   124,    85,   124,     0,
   124,    86,   124,     0,   124,    87,   124,     0,   124,    88,
   124,     0,   124,    89,   124,     0,   124,    91,   124,     0,
   124,    90,   124,     0,   124,    92,   124,     0,   124,    93,
   124,     0,   124,    94,   124,     0,   124,    95,   124,     0,
   124,    96,   124,     0,   103,   124,   104,     0,    31,     0,
    32,     0,    30,     0,    83,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   155,   156,   159,   216,   217,   218,   219,   220,   221,   222,
   223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
   233,   233,   234,   235,   236,   237,   238,   239,   240,   247,
   251,   264,   282,   283,   287,   288,   291,   292,   293,   296,
   297,   300,   301,   302,   303,   304,   305,   306,   307,   308,
   309,   310,   311,   312,   313,   314,   315,   316,   317,   318,
   319,   320,   321,   322,   323,   324,   325,   326,   327,   331,
   332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
   342,   351,   352,   353,   354,   355,   363,   364,   365,   372,
   379,   389,   390,   391,   401,   401,   402,   403,   404,   405,
   406,   407,   408,   409,   411,   412,   413,   413,   414,   414,
   415,   415,   416,   416,   417,   417,   418,   418,   419,   419,
   423,   433,   446,   447,   448,   449,   450,   451,   452,   453,
   454,   455,   456,   457,   458,   459,   460,   461,   462,   463,
   466,   467,   468,   492
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","PTR","ID",
"LAM","STRING","CHR","REAL","EXREAL","CMP","EXCMP","DOCOL","SEMI","SYMBOL","UNIT",
"MATRIX","TAG","ROMPTR","FPTR","ACPTR","LENBODYOB","NIBB","NIBBHEX","ZINT","CODE",
"ENDCODE","LABEL","DEFINE","DCCP","NAME","NUMBER","HEX_NUMBER","HEX_REV_NUMBER",
"MNEMADDSUB","MNEMADDSUBCON","MNEMZEROETAL","MNEMLOGICAL","MNEMSRB","MNEMACLD",
"MNEMMEMORY","MNEMBIT","MNEMDATREGADD","MNEMDATREGLD","MNEMPLD","MNEMSCRATCHREG",
"MNEMCPASN","MNEMSETST","MNEMGOTO","MNEMGOTOC","MNEMTEST1","MNEMTEST2","MNEMTEST3",
"MNEMTEST4","MNEMTEST5","MNEMNOFIELD2","MNEMNOFIELD3","MNEMNOFIELD4","MNEMNOFIELD5",
"SKIP","SKUB","SKIPC","SKIPNC","SKIPL","SKUBL","SKIPYES","EXIT","UP","EXITC",
"UPC","EXITNC","UPNC","STROBJ","FIELD","CON","GOINAC","GOINN","CP","GOYES","RTNYES",
"ARROW","'!'","'^'","'&'","'#'","'='","'>'","'<'","GE","LE","'-'","'+'","'*'",
"'/'","'%'","LSHIFT","RSHIFT","'$'","'{'","'}'","'\\n'","'.'","':'","'('","')'",
"object","realobject","@1","specialaction","objects","codeinput","line","mnemonics",
"mnemonic","@2","@3","@4","@5","@6","@7","@8","@9","@10","constnames","expr",
"number", NULL
};
#endif

static const short yyr1[] = {     0,
   105,   105,   106,   106,   106,   106,   106,   106,   106,   106,
   106,   106,   106,   106,   106,   106,   106,   106,   106,   107,
   106,   106,   106,   106,   106,   106,   106,   106,   106,   108,
   108,   108,   109,   109,   110,   110,   111,   111,   111,   112,
   112,   113,   113,   113,   113,   113,   113,   113,   113,   113,
   113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
   113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
   113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
   113,   113,   113,   113,   113,   113,   113,   113,   113,   113,
   113,   113,   113,   113,   114,   113,   113,   113,   113,   113,
   113,   113,   113,   115,   113,   113,   116,   113,   117,   113,
   118,   113,   119,   113,   120,   113,   121,   113,   122,   113,
   123,   123,   124,   124,   124,   124,   124,   124,   124,   124,
   124,   124,   124,   124,   124,   124,   124,   124,   124,   124,
   125,   125,   125,   125
};

static const short yyr2[] = {     0,
     1,     2,     1,     2,     2,     2,     2,     1,     2,     1,
     2,     2,     3,     3,     3,     3,     3,     3,     3,     0,
     4,     3,     3,     3,     3,     3,     2,     2,     3,     2,
     3,     3,     0,     2,     0,     2,     1,     2,     2,     1,
     2,     2,     3,     3,     4,     2,     3,     2,     3,     2,
     3,     2,     2,     3,     2,     3,     2,     3,     2,     2,
     2,     3,     2,     2,     3,     2,     3,     2,     2,     2,
     3,     2,     3,     2,     3,     1,     2,     3,     2,     2,
     1,     1,     1,     1,     1,     3,     3,     2,     1,     1,
     2,     2,     2,     3,     0,     5,     1,     1,     1,     1,
     1,     1,     3,     0,     5,     4,     0,     5,     0,     5,
     0,     5,     0,     5,     0,     5,     0,     5,     0,     6,
     1,     2,     1,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     1,     1,     1,     1
};

static const short yydefact[] = {     0,
     0,     0,     0,     8,    10,     0,     0,     0,     0,    33,
    33,    33,    33,     0,     0,     0,     0,     0,     0,     0,
     0,    35,     0,     0,     0,     3,     0,     0,    33,     1,
     0,     5,     6,     7,    11,    12,     0,     0,     0,     0,
     0,     0,    20,     0,     0,     0,     0,     0,    27,    28,
     0,    30,     0,     0,     4,     9,     0,     2,    13,    14,
    15,    34,    17,    18,    19,     0,    22,    23,    24,    25,
    26,     0,    29,     0,     0,    89,    90,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    76,     0,    82,    83,
    84,    85,     0,     0,     0,     0,     0,     0,   104,    97,
    98,    99,   100,   101,   102,     0,     0,     0,     0,     0,
     0,    81,     0,    35,    37,     0,    36,     0,    40,    31,
    32,    16,    21,    39,     0,     0,   143,   141,   142,   144,
     0,     0,   123,    42,     0,     0,    46,     0,    48,     0,
    50,     0,    52,    53,     0,    55,     0,    57,    59,    60,
    63,    61,     0,     0,    64,     0,    66,    68,    69,    70,
     0,    72,     0,     0,    74,     0,    77,   107,   109,   111,
   113,   115,   117,     0,     0,    88,    91,    92,    93,    79,
    35,    80,     0,    95,    38,    41,    86,    87,     0,    94,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    43,    44,     0,    47,
    49,    51,    54,    56,    58,    62,    65,    67,    71,    73,
    75,    78,    35,    35,    35,    35,    35,    35,    35,   119,
     0,   103,     0,   140,   124,   125,   126,   127,   128,   129,
   130,   131,   132,   134,   133,   135,   136,   137,   138,   139,
    45,     0,     0,     0,     0,     0,     0,     0,    35,   106,
   121,     0,   108,   110,   112,   114,   116,   118,   105,     0,
   122,    96,   120,     0,     0,     0
};

static const short yydefgoto[] = {    62,
    30,    66,    31,    39,    51,   127,   128,   129,   243,   184,
   233,   234,   235,   236,   237,   238,   269,   272,   142,   143
};

static const short yypact[] = {  1227,
   -11,    21,    40,-32768,-32768,    19,    26,    29,    32,-32768,
-32768,-32768,-32768,    45,    36,    38,    46,    50,    55,    63,
    65,-32768,    67,    70,    73,-32768,    76,   102,-32768,-32768,
  1227,-32768,-32768,-32768,-32768,-32768,   109,   158,  1043,  1073,
  1169,  1197,-32768,   184,   186,   191,   192,   238,-32768,-32768,
   115,-32768,   266,   268,-32768,-32768,  1015,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,  1227,-32768,-32768,-32768,-32768,
-32768,   125,-32768,   -13,  1348,-32768,-32768,   -49,  1348,   -48,
   -47,   -36,  1348,    -9,   -28,  1348,  1348,  1348,   -29,    -2,
     1,  1348,  1348,   -23,   -12,     4,-32768,    39,-32768,-32768,
-32768,-32768,   128,   201,   203,   204,   207,   208,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,  1348,  1348,  1348,  1348,  1348,
  1348,-32768,  1284,-32768,-32768,  1348,-32768,  1294,-32768,-32768,
-32768,-32768,-32768,-32768,  1348,  1348,-32768,-32768,-32768,-32768,
  1348,   116,-32768,-32768,   284,  1316,-32768,   295,-32768,   296,
-32768,   297,   356,-32768,  1345,   356,  1348,   356,   356,   356,
   356,-32768,   298,  1348,   356,  1348,   356,   356,   356,-32768,
   299,-32768,   305,  1348,   356,  1348,   356,-32768,-32768,-32768,
-32768,-32768,-32768,   250,  1351,   356,   356,   356,   356,   356,
-32768,   356,   195,   356,-32768,-32768,   356,   356,   196,-32768,
  1348,  1348,  1348,  1348,  1348,  1348,  1348,  1348,  1348,  1348,
  1348,  1348,  1348,  1348,  1348,  1348,-32768,-32768,   306,-32768,
-32768,-32768,-32768,   356,   356,-32768,   356,   356,-32768,-32768,
   356,   356,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   275,-32768,   350,-32768,   434,   434,   513,   271,   271,   271,
   271,   271,   271,    25,    25,   124,   124,    -5,-32768,-32768,
-32768,   355,   435,   515,   595,   675,   755,   835,-32768,-32768,
-32768,   -19,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   915,
-32768,-32768,-32768,   381,   382,-32768
};

static const short yypgoto[] = {    16,
-32768,-32768,-32768,   347,  -124,-32768,-32768,   257,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -78,-32768
};


#define	YYLAST		1451


static const short yytable[] = {   193,
   146,   137,   138,   139,   153,   156,   158,   159,   160,   161,
   281,   165,   167,   168,   169,   284,   135,   175,    32,   177,
   137,   138,   139,   144,   147,   149,    33,   137,   138,   139,
   137,   138,   139,   137,   138,   139,   151,   185,   186,   187,
   188,   189,   190,   162,   192,    34,    58,   194,    35,   170,
    43,   145,   148,   150,   140,    36,   197,   198,    37,   136,
   172,    38,   199,   154,   152,    44,   241,    45,   137,   138,
   139,   163,   157,   140,   141,    46,   224,   171,   225,    47,
   140,   133,   282,   140,    48,   227,   140,   228,   173,   215,
   216,   155,    49,   141,    50,   231,    52,   232,   164,    53,
   141,   166,    54,   141,   174,    55,   141,    56,   262,   263,
   264,   265,   266,   267,   268,    72,   212,   213,   214,   215,
   216,   140,   245,   246,   247,   248,   249,   250,   251,   252,
   253,   254,   255,   256,   257,   258,   259,   260,    59,   176,
    73,   141,    74,    75,   280,   200,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,    60,   117,   118,
   119,   120,   121,   122,   123,    72,   201,   202,   203,   204,
   205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
   215,   216,   124,    67,   125,    68,   126,   214,   215,   216,
    69,    70,    74,    75,   134,   178,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,    71,   117,   118,
   119,   120,   121,   122,   123,    72,   201,   202,   203,   204,
   205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
   215,   216,   124,   242,   125,   130,   126,   131,   179,   244,
   180,   181,    74,    75,   182,   183,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,   239,   117,   118,
   119,   120,   121,   122,   123,    72,   217,    40,    41,    42,
   210,   211,   212,   213,   214,   215,   216,   220,   221,   222,
   226,   229,   124,   270,   125,    57,   126,   230,   261,   271,
   285,   286,    74,    75,   196,     0,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,     0,   117,   118,
   119,   120,   121,   122,   123,    72,   201,   202,   203,   204,
   205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
   215,   216,   124,   273,   125,     0,   126,     0,     0,     0,
     0,     0,    74,    75,     0,     0,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,     0,   117,   118,
   119,   120,   121,   122,   123,    72,   203,   204,   205,   206,
   207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     0,     0,   124,   274,   125,     0,   126,     0,     0,     0,
     0,     0,    74,    75,     0,     0,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,     0,   117,   118,
   119,   120,   121,   122,   123,    72,   204,   205,   206,   207,
   208,   209,   210,   211,   212,   213,   214,   215,   216,     0,
     0,     0,   124,   275,   125,     0,   126,     0,     0,     0,
     0,     0,    74,    75,     0,     0,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,     0,   117,   118,
   119,   120,   121,   122,   123,    72,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   124,   276,   125,     0,   126,     0,     0,     0,
     0,     0,    74,    75,     0,     0,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,     0,   117,   118,
   119,   120,   121,   122,   123,    72,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   124,   277,   125,     0,   126,     0,     0,     0,
     0,     0,    74,    75,     0,     0,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,     0,   117,   118,
   119,   120,   121,   122,   123,    72,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   124,   278,   125,     0,   126,     0,     0,     0,
     0,     0,    74,    75,     0,     0,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,     0,   117,   118,
   119,   120,   121,   122,   123,    72,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   124,   279,   125,     0,   126,     0,     0,     0,
     0,     0,    74,    75,     0,     0,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
   110,   111,   112,   113,   114,   115,   116,     0,   117,   118,
   119,   120,   121,   122,   123,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   124,   283,   125,     0,   126,     1,     2,     3,
     4,     5,     6,     7,     8,     9,    10,     0,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
     0,    23,    24,    25,    26,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    61,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,     0,    23,
    24,    25,    26,     0,     0,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    63,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    27,    23,
    24,    25,    26,     0,     0,     0,     0,     0,     0,     0,
     0,    28,    29,   132,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    27,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    28,
    29,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    27,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    28,
    29,     1,     2,     3,     4,     5,     6,     7,     8,     9,
    10,    64,    11,    12,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,     0,    23,    24,    25,    26,     1,
     2,     3,     4,     5,     6,     7,     8,     9,    10,    65,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,     0,    23,    24,    25,    26,     0,     0,     1,
     2,     3,     4,     5,     6,     7,     8,     9,    10,     0,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    27,    23,    24,    25,    26,     0,     0,     0,
     0,     0,     0,     0,     0,    28,    29,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    27,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    28,    29,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    27,     0,     0,   137,   138,   139,     0,     0,     0,     0,
     0,    74,    75,    28,    29,    76,    77,    78,    79,    80,
    81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
    91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
   101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
   111,   112,   113,   114,   115,   116,   140,   117,   118,   119,
   120,   121,   122,   123,   137,   138,   139,   137,   138,   139,
     0,   191,     0,     0,     0,     0,   141,     0,   218,     0,
     0,   124,     0,   195,     0,   126,   201,   202,   203,   204,
   205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
   215,   216,     0,     0,     0,     0,   219,   223,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   140,     0,     0,
   140,   201,   202,   203,   204,   205,   206,   207,   208,   209,
   210,   211,   212,   213,   214,   215,   216,   141,   240,     0,
   141
};

static const short yycheck[] = {   124,
    79,    30,    31,    32,    83,    84,    85,    86,    87,    88,
    30,    90,    91,    92,    93,     0,    30,    96,    30,    98,
    30,    31,    32,    73,    73,    73,     6,    30,    31,    32,
    30,    31,    32,    30,    31,    32,    73,   116,   117,   118,
   119,   120,   121,    73,   123,     6,    31,   126,    30,    73,
     6,   101,   101,   101,    83,    30,   135,   136,    30,    73,
    73,    30,   141,    73,   101,    30,   191,    30,    30,    31,
    32,   101,   101,    83,   103,    30,   155,   101,   157,    30,
    83,    66,   102,    83,    30,   164,    83,   166,   101,    95,
    96,   101,    30,   103,    30,   174,    30,   176,   101,    30,
   103,   101,    30,   103,   101,    30,   103,     6,   233,   234,
   235,   236,   237,   238,   239,     1,    92,    93,    94,    95,
    96,    83,   201,   202,   203,   204,   205,   206,   207,   208,
   209,   210,   211,   212,   213,   214,   215,   216,    30,   101,
    26,   103,    28,    29,   269,    30,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    30,    74,    75,
    76,    77,    78,    79,    80,     1,    81,    82,    83,    84,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    95,    96,    98,    30,   100,    30,   102,    94,    95,    96,
    30,    30,    28,    29,   100,    98,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    30,    74,    75,
    76,    77,    78,    79,    80,     1,    81,    82,    83,    84,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    95,    96,    98,    99,   100,    30,   102,    30,    98,   104,
    98,    98,    28,    29,    98,    98,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    98,    74,    75,
    76,    77,    78,    79,    80,     1,    73,    11,    12,    13,
    90,    91,    92,    93,    94,    95,    96,    73,    73,    73,
    73,    73,    98,    99,   100,    29,   102,    73,    73,    30,
     0,     0,    28,    29,   128,    -1,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    -1,    74,    75,
    76,    77,    78,    79,    80,     1,    81,    82,    83,    84,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    95,    96,    98,    99,   100,    -1,   102,    -1,    -1,    -1,
    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    -1,    74,    75,
    76,    77,    78,    79,    80,     1,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    -1,    -1,    98,    99,   100,    -1,   102,    -1,    -1,    -1,
    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    -1,    74,    75,
    76,    77,    78,    79,    80,     1,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    -1,
    -1,    -1,    98,    99,   100,    -1,   102,    -1,    -1,    -1,
    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    -1,    74,    75,
    76,    77,    78,    79,    80,     1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    98,    99,   100,    -1,   102,    -1,    -1,    -1,
    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    -1,    74,    75,
    76,    77,    78,    79,    80,     1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    98,    99,   100,    -1,   102,    -1,    -1,    -1,
    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    -1,    74,    75,
    76,    77,    78,    79,    80,     1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    98,    99,   100,    -1,   102,    -1,    -1,    -1,
    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    -1,    74,    75,
    76,    77,    78,    79,    80,     1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    98,    99,   100,    -1,   102,    -1,    -1,    -1,
    -1,    -1,    28,    29,    -1,    -1,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    -1,    74,    75,
    76,    77,    78,    79,    80,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    98,    99,   100,    -1,   102,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    -1,    27,    28,    29,    30,     3,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    -1,    27,
    28,    29,    30,    -1,    -1,     3,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    84,    27,
    28,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    97,    98,    99,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,
    98,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    97,
    98,     3,     4,     5,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    -1,    27,    28,    29,    30,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    -1,    27,    28,    29,    30,    -1,    -1,     3,
     4,     5,     6,     7,     8,     9,    10,    11,    12,    -1,
    14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
    24,    25,    84,    27,    28,    29,    30,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    97,    98,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    97,    98,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    84,    -1,    -1,    30,    31,    32,    -1,    -1,    -1,    -1,
    -1,    28,    29,    97,    98,    32,    33,    34,    35,    36,
    37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
    47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
    57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
    67,    68,    69,    70,    71,    72,    83,    74,    75,    76,
    77,    78,    79,    80,    30,    31,    32,    30,    31,    32,
    -1,    98,    -1,    -1,    -1,    -1,   103,    -1,    73,    -1,
    -1,    98,    -1,   100,    -1,   102,    81,    82,    83,    84,
    85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
    95,    96,    -1,    -1,    -1,    -1,   101,    73,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    83,    -1,    -1,
    83,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,   103,    98,    -1,
   103
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"
/* This file comes from bison-1.28.  */

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

#ifndef YYSTACK_USE_ALLOCA
#ifdef alloca
#define YYSTACK_USE_ALLOCA
#else /* alloca not defined */
#ifdef __GNUC__
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi) || (defined (__sun) && defined (__i386))
#define YYSTACK_USE_ALLOCA
#include <alloca.h>
#else /* not sparc */
/* We think this test detects Watcom and Microsoft C.  */
/* This used to test MSDOS, but that is a bad idea
   since that symbol is in the user namespace.  */
#if (defined (_MSDOS) || defined (_MSDOS_)) && !defined (__TURBOC__)
#if 0 /* No need for malloc.h, which pollutes the namespace;
	 instead, just don't use alloca.  */
#include <malloc.h>
#endif
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
/* I don't know what this was needed for, but it pollutes the namespace.
   So I turned it off.   rms, 2 May 1997.  */
/* #include <malloc.h>  */
 #pragma alloca
#define YYSTACK_USE_ALLOCA
#else /* not MSDOS, or __TURBOC__, or _AIX */
#if 0
#ifdef __hpux /* haible@ilog.fr says this works for HPUX 9.05 and up,
		 and on HPUX 10.  Eventually we can turn this on.  */
#define YYSTACK_USE_ALLOCA
#define alloca __builtin_alloca
#endif /* __hpux */
#endif
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc */
#endif /* not GNU C */
#endif /* alloca not defined */
#endif /* YYSTACK_USE_ALLOCA not defined */

#ifdef YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#define YYSTACK_ALLOC malloc
#endif

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Define __yy_memcpy.  Note that the size argument
   should be passed with type unsigned int, because that is what the non-GCC
   definitions require.  With GCC, __builtin_memcpy takes an arg
   of type size_t, but it can handle unsigned int.  */

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     unsigned int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, unsigned int count)
{
  register char *t = to;
  register char *f = from;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 217 "/usr/lib/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
#ifdef YYPARSE_PARAM
int yyparse (void *);
#else
int yyparse (void);
#endif
#endif

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;
  int yyfree_stacks = 0;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  if (yyfree_stacks)
	    {
	      free (yyss);
	      free (yyvs);
#ifdef YYLSP_NEEDED
	      free (yyls);
#endif
	    }
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
#ifndef YYSTACK_USE_ALLOCA
      yyfree_stacks = 1;
#endif
      yyss = (short *) YYSTACK_ALLOC (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1,
		   size * (unsigned int) sizeof (*yyssp));
      yyvs = (YYSTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1,
		   size * (unsigned int) sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) YYSTACK_ALLOC (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1,
		   size * (unsigned int) sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 159 "kasm_parser.yy"
{
        Entry_Table_iter i = file_entries.find(yyvsp[0].str);
        Entry* ent = 0;
        if (i != file_entries.end()) {
                ent = i->second;
        } else {
                i = global_entries.find(yyvsp[0].str);
                if (i == global_entries.end() && !firstpass) {
                        char *rest;
                        unsigned long n = strtoul(yyvsp[0].str, &rest, 10);
                        if (!*rest && yyvsp[0].str[0] != '-') {
                                unsigned long addr = get_address_of("DOBINT");
                                if (addr == 0) {
                                        yyerror("Cannot find bint prolog (DOBINT)", true);
                                }
                                outputreverse(addr, 5);
                                outputreverse(n, 5);
                        } else {
                                if (strspn(yyvsp[0].str, "0123456789eE+-.") != strlen(yyvsp[0].str))
                                        yyerror("Cannot find entry", true);
                                else
                                        doreal(yyvsp[0].str);
                        }
                } else
                        ent = i->second;
        }
        if (ent != 0)
                switch (ent->type()) {
                case T_POINTER:
                        outputreverse(ent->get_address(), 5);
                        break;
                
                case T_FLASHPTR: {
                        unsigned long addr = get_address_of("DOFLASHP");
                        if (addr == 0)
                                yyerror("Cannot find address of flashpointer prolog (DOFLASHP)", true);
                        else
                                outputreverse(addr, 5);
                        Flashptr* fptr = dynamic_cast<Flashptr*>(ent);
                        outputreverse(fptr->bank_num(), 3);
                        outputreverse(fptr->cmd_num(), 4);
                        break;
                }

                case T_ROMPTR: {
                        unsigned long addr = get_address_of("DOROMP");
                        if (addr == 0)
                                yyerror("Cannot find address of rompointer prolog (DOROMP)", true);
                        else
                                outputreverse(addr, 5);
                        Romptr* rptr = dynamic_cast<Romptr*>(ent);
                        outputreverse(rptr->lib_num(), 3);
                        outputreverse(rptr->cmd_num(), 3);
                        break;
                }
                }
;
    break;}
case 4:
#line 216 "kasm_parser.yy"
{ doptrbint(yyvsp[0].str, false); ;
    break;}
case 5:
#line 217 "kasm_parser.yy"
{ doptrbint(yyvsp[0].str, true); ;
    break;}
case 6:
#line 218 "kasm_parser.yy"
{ doId(yyvsp[0].str, true); ;
    break;}
case 7:
#line 219 "kasm_parser.yy"
{ doId(yyvsp[0].str, false); ;
    break;}
case 8:
#line 220 "kasm_parser.yy"
{ dostring(yyvsp[0].str); ;
    break;}
case 9:
#line 221 "kasm_parser.yy"
{ dostring(yyvsp[0].str); ;
    break;}
case 10:
#line 222 "kasm_parser.yy"
{ dochar(yyvsp[0].chr); ;
    break;}
case 11:
#line 223 "kasm_parser.yy"
{ doreal(yyvsp[0].str); ;
    break;}
case 12:
#line 224 "kasm_parser.yy"
{ doexreal(yyvsp[0].str); ;
    break;}
case 13:
#line 225 "kasm_parser.yy"
{ docmp(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 14:
#line 226 "kasm_parser.yy"
{ doexcmp(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 20:
#line 232 "kasm_parser.yy"
{ dotag(yyvsp[0].str); ;
    break;}
case 22:
#line 233 "kasm_parser.yy"
{ doromptr(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 23:
#line 234 "kasm_parser.yy"
{ doflashptr(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 24:
#line 235 "kasm_parser.yy"
{ doacptr(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 25:
#line 236 "kasm_parser.yy"
{ dolenbody(yyvsp[-2].str, yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 26:
#line 237 "kasm_parser.yy"
{ donibb(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 27:
#line 238 "kasm_parser.yy"
{ donibb(0, yyvsp[0].str); ;
    break;}
case 28:
#line 239 "kasm_parser.yy"
{ dozint(yyvsp[0].str); ;
    break;}
case 29:
#line 240 "kasm_parser.yy"
{
        if (firstpass)
                code_lens.push_front(pc - code_begin);
;
    break;}
case 30:
#line 247 "kasm_parser.yy"
{
        if (firstpass)
                file_entries.insert(make_pair(string(yyvsp[0].str), new Pointer(pc)));
;
    break;}
case 31:
#line 251 "kasm_parser.yy"
{
        char *rest;
        unsigned long addr = strtoul(yyvsp[0].str, &rest, 16);
        if (*rest)
                yyerror("Hexa expected");

        Entry_Table_iter i = file_entries.find(yyvsp[-1].str);
        if (i != file_entries.end()) {
                if (i->second->get_address() != addr)
                        yyerror("warning: Redefinition of label; ignored");
        } else
                file_entries.insert(make_pair(string(yyvsp[-1].str), new Pointer(addr)));
;
    break;}
case 32:
#line 264 "kasm_parser.yy"
{
        char *rest;
        unsigned long val = strtoul(yyvsp[-1].str, &rest, 16);
        if (*rest)
                yyerror("Hexa expected");

        Entry_Table_iter i = file_entries.find(yyvsp[0].str);
        if (i != file_entries.end()) {
                if (i->second->get_address() != constpointer)
                        yyerror("warning: Redefinition of label; ignored");
        } else {
                file_entries.insert(make_pair(string(yyvsp[0].str), new Pointer(constpointer)));
                constpointer += val;
        }
;
    break;}
case 39:
#line 293 "kasm_parser.yy"
{ yyerrok; ;
    break;}
case 42:
#line 300 "kasm_parser.yy"
{ mnemaddsub(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 43:
#line 301 "kasm_parser.yy"
{ mnemaddsub(yyvsp[-2].str, yyvsp[0].str); ;
    break;}
case 44:
#line 302 "kasm_parser.yy"
{ mnemaddsubcon(yyvsp[-2].str, yyvsp[0].str, yyvsp[-1].number); ;
    break;}
case 45:
#line 303 "kasm_parser.yy"
{ mnemaddsubcon(yyvsp[-3].str, yyvsp[0].str, yyvsp[-2].number); ;
    break;}
case 46:
#line 304 "kasm_parser.yy"
{ mnemzeroetal(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 47:
#line 305 "kasm_parser.yy"
{ mnemzeroetal(yyvsp[-2].str, yyvsp[0].str); ;
    break;}
case 48:
#line 306 "kasm_parser.yy"
{ mnemlogical(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 49:
#line 307 "kasm_parser.yy"
{ mnemlogical(yyvsp[-2].str, yyvsp[0].str); ;
    break;}
case 50:
#line 308 "kasm_parser.yy"
{ mnemsrb(yyvsp[-1].number, yyvsp[0].str); ;
    break;}
case 51:
#line 309 "kasm_parser.yy"
{ mnemsrb(yyvsp[-2].number, yyvsp[0].str); ;
    break;}
case 52:
#line 310 "kasm_parser.yy"
{ mnemacld(yyvsp[-1].str, yyvsp[0].number); ;
    break;}
case 53:
#line 311 "kasm_parser.yy"
{ mnemmemoryf(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 54:
#line 312 "kasm_parser.yy"
{ mnemmemoryf(yyvsp[-2].str, yyvsp[0].str); ;
    break;}
case 55:
#line 313 "kasm_parser.yy"
{ mnemmemoryn(yyvsp[-1].str, yyvsp[0].number); ;
    break;}
case 56:
#line 314 "kasm_parser.yy"
{ mnemmemoryn(yyvsp[-2].str, yyvsp[0].number); ;
    break;}
case 57:
#line 315 "kasm_parser.yy"
{ mnembit(yyvsp[-1].number, yyvsp[0].number); ;
    break;}
case 58:
#line 316 "kasm_parser.yy"
{ mnembit(yyvsp[-2].number, yyvsp[0].number); ;
    break;}
case 59:
#line 317 "kasm_parser.yy"
{ mnemdatregadd(yyvsp[-1].str, yyvsp[0].number); ;
    break;}
case 60:
#line 318 "kasm_parser.yy"
{ mnemdatregld(yyvsp[-1].str, (unsigned long)yyvsp[0].number); ;
    break;}
case 61:
#line 319 "kasm_parser.yy"
{ mnemscratchreg(yyvsp[-1].number, yyvsp[0].str); ;
    break;}
case 62:
#line 320 "kasm_parser.yy"
{ mnemscratchreg(yyvsp[-2].number, yyvsp[0].str); ;
    break;}
case 63:
#line 321 "kasm_parser.yy"
{ mnempld(yyvsp[0].number); ;
    break;}
case 64:
#line 322 "kasm_parser.yy"
{ mnemcpasn(yyvsp[-1].number, yyvsp[0].number); ;
    break;}
case 65:
#line 323 "kasm_parser.yy"
{ mnemcpasn(yyvsp[-2].number, yyvsp[0].number); ;
    break;}
case 66:
#line 324 "kasm_parser.yy"
{ mnemsetst(yyvsp[-1].number, yyvsp[0].number); ;
    break;}
case 67:
#line 325 "kasm_parser.yy"
{ mnemsetst(yyvsp[-2].number, yyvsp[0].number); ;
    break;}
case 68:
#line 326 "kasm_parser.yy"
{ mnemgoto(yyvsp[-1].str, yyvsp[0].number); ;
    break;}
case 69:
#line 327 "kasm_parser.yy"
{
        output(yyvsp[-1].number | 0x60, 3);      /* GOC or GONC 6 nibbles futher */
        mnemgoto("GOTO", yyvsp[0].number);
;
    break;}
case 70:
#line 331 "kasm_parser.yy"
{ mnemtest1(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 71:
#line 332 "kasm_parser.yy"
{ mnemtest1(yyvsp[-2].str, yyvsp[0].str); ;
    break;}
case 72:
#line 333 "kasm_parser.yy"
{ mnemtest2(yyvsp[-1].str, yyvsp[0].str); ;
    break;}
case 73:
#line 334 "kasm_parser.yy"
{ mnemtest2(yyvsp[-2].str, yyvsp[0].str); ;
    break;}
case 74:
#line 335 "kasm_parser.yy"
{ mnemtest3(yyvsp[-1].number, yyvsp[0].number); ;
    break;}
case 75:
#line 336 "kasm_parser.yy"
{ mnemtest3(yyvsp[-2].number, yyvsp[0].number); ;
    break;}
case 76:
#line 337 "kasm_parser.yy"
{ last_test_opcode = yyvsp[0].number; last_test_len = 3; ;
    break;}
case 77:
#line 338 "kasm_parser.yy"
{ mnemtest5(yyvsp[-1].number, yyvsp[0].number); ;
    break;}
case 78:
#line 339 "kasm_parser.yy"
{ mnemtest5(yyvsp[-2].number, yyvsp[0].number); ;
    break;}
case 79:
#line 340 "kasm_parser.yy"
{ goyes(yyvsp[0].number); ;
    break;}
case 80:
#line 341 "kasm_parser.yy"
{ goyes(yyvsp[0].number); ;
    break;}
case 81:
#line 342 "kasm_parser.yy"
{
        if (last_test_len) {
                int len = last_test_len;
                last_test_len = 0;
                output(last_test_opcode, len);
                output(0, 2);
        } else
                yyerror("Must follow a test");
;
    break;}
case 82:
#line 351 "kasm_parser.yy"
{ mnemnofield2(yyvsp[0].str); ;
    break;}
case 83:
#line 352 "kasm_parser.yy"
{ mnemnofield3(yyvsp[0].str); ;
    break;}
case 84:
#line 353 "kasm_parser.yy"
{ mnemnofield4(yyvsp[0].str); ;
    break;}
case 85:
#line 354 "kasm_parser.yy"
{ output(yyvsp[0].number, 5); ;
    break;}
case 86:
#line 355 "kasm_parser.yy"
{
        Entry_Table_iter i = file_entries.find(yyvsp[-1].str);
        if (i != file_entries.end()) {
                if (i->second->get_address() != (unsigned long)yyvsp[0].number)
                        yyerror("warning: Redefinition of label; ignored");
        } else
                file_entries.insert(make_pair(string(yyvsp[-1].str), new Pointer(yyvsp[0].number)));
;
    break;}
case 87:
#line 363 "kasm_parser.yy"
{ yyerror("Invalid constant name"); ;
    break;}
case 88:
#line 364 "kasm_parser.yy"
{ outputreverse(yyvsp[0].number, yyvsp[-1].number); ;
    break;}
case 89:
#line 365 "kasm_parser.yy"
{
        for (unsigned int i = 0; i < strlen(yyvsp[0].str); ++i)
                if (yyvsp[0].str[i] >= 'A')
                        output(yyvsp[0].str[i] - 'A' + 10, 1);
                else
                        output(yyvsp[0].str[i] - '0', 1);
;
    break;}
case 90:
#line 372 "kasm_parser.yy"
{
        for (int i = strlen(yyvsp[0].str) - 1; i >= 0; --i)
                if (yyvsp[0].str[i] >= 'A')
                        output(yyvsp[0].str[i] - 'A' + 10, 1);
                else
                        output(yyvsp[0].str[i] - '0', 1);
;
    break;}
case 91:
#line 379 "kasm_parser.yy"
{
        long value = yyvsp[0].number - pc;
        if (yyvsp[-1].number == 0)
                output(3, 1);
        else
                output(0x8082, 4);

        output(4, 1);
        outputreverse(value, 5);
;
    break;}
case 92:
#line 389 "kasm_parser.yy"
{ outputreverse(yyvsp[0].number - pc, yyvsp[-1].number); ;
    break;}
case 93:
#line 390 "kasm_parser.yy"
{ constpointer = yyvsp[0].number; ;
    break;}
case 94:
#line 391 "kasm_parser.yy"
{
        Entry_Table_iter i = file_entries.find(yyvsp[0].str);
        if (i != file_entries.end()) {
                if (i->second->get_address() != constpointer)
                        yyerror("warning: Redefinition of label; ignored");
        } else {
                file_entries.insert(make_pair(string(yyvsp[0].str), new Pointer(constpointer)));
                constpointer += yyvsp[-1].number;
        }
;
    break;}
case 95:
#line 401 "kasm_parser.yy"
{ cpointerincr = yyvsp[0].number; ;
    break;}
case 97:
#line 402 "kasm_parser.yy"
{ mnemexitorup(yyvsp[0].number, true); ;
    break;}
case 98:
#line 403 "kasm_parser.yy"
{ mnemexitorup(yyvsp[0].number, false); ;
    break;}
case 99:
#line 404 "kasm_parser.yy"
{ mnemexitorup_c(yyvsp[0].number, true, true); ;
    break;}
case 100:
#line 405 "kasm_parser.yy"
{ mnemexitorup_c(yyvsp[0].number, false, true); ;
    break;}
case 101:
#line 406 "kasm_parser.yy"
{ mnemexitorup_c(yyvsp[0].number, true, false); ;
    break;}
case 102:
#line 407 "kasm_parser.yy"
{ mnemexitorup_c(yyvsp[0].number, false, false); ;
    break;}
case 103:
#line 408 "kasm_parser.yy"
{ mnemskelse(); ;
    break;}
case 104:
#line 409 "kasm_parser.yy"
{ 
        if (last_test_len == 0)
                yyerror("Forbidden"); ;
    break;}
case 105:
#line 411 "kasm_parser.yy"
{ mnemskelse(); ;
    break;}
case 106:
#line 412 "kasm_parser.yy"
{ mnemskelse(); ;
    break;}
case 107:
#line 413 "kasm_parser.yy"
{ mnemskip(false); ;
    break;}
case 109:
#line 414 "kasm_parser.yy"
{ mnemskip(true); ;
    break;}
case 111:
#line 415 "kasm_parser.yy"
{ mnemskip_c(true); ;
    break;}
case 113:
#line 416 "kasm_parser.yy"
{ mnemskip_c(false); ;
    break;}
case 115:
#line 417 "kasm_parser.yy"
{ mnemskip_l(false); ;
    break;}
case 117:
#line 418 "kasm_parser.yy"
{ mnemskip_l(true); ;
    break;}
case 119:
#line 419 "kasm_parser.yy"
{ mnemstrobj(yyvsp[-1].number); ;
    break;}
case 121:
#line 423 "kasm_parser.yy"
{
        Entry_Table_iter i = file_entries.find(yyvsp[0].str);
        if (i != file_entries.end()) {
                if (i->second->get_address() != constpointer)
                        yyerror("warning: Redefinition of label; ignored");
        } else {
                file_entries.insert(make_pair(string(yyvsp[0].str), new Pointer(constpointer)));
                constpointer += cpointerincr;
        }
;
    break;}
case 122:
#line 433 "kasm_parser.yy"
{
        Entry_Table_iter i = file_entries.find(yyvsp[0].str);
        if (i != file_entries.end()) {
                if (i->second->get_address() != constpointer)
                        yyerror("warning: Redefinition of label; ignored");
        } else {
                file_entries.insert(make_pair(string(yyvsp[0].str), new Pointer(constpointer)));
                constpointer += cpointerincr;
        }
;
    break;}
case 123:
#line 446 "kasm_parser.yy"
{ yyval.number = yyvsp[0].number; ;
    break;}
case 124:
#line 447 "kasm_parser.yy"
{ yyval.number = yyvsp[-2].number | yyvsp[0].number; ;
    break;}
case 125:
#line 448 "kasm_parser.yy"
{ yyval.number = (yyvsp[-2].number & ~yyvsp[0].number) | (~yyvsp[-2].number & yyvsp[0].number); ;
    break;}
case 126:
#line 449 "kasm_parser.yy"
{ yyval.number = yyvsp[-2].number & yyvsp[0].number; ;
    break;}
case 127:
#line 450 "kasm_parser.yy"
{ yyval.number = (yyvsp[-2].number != yyvsp[0].number); ;
    break;}
case 128:
#line 451 "kasm_parser.yy"
{ yyval.number = (yyvsp[-2].number == yyvsp[0].number); ;
    break;}
case 129:
#line 452 "kasm_parser.yy"
{ yyval.number = (yyvsp[-2].number > yyvsp[0].number); ;
    break;}
case 130:
#line 453 "kasm_parser.yy"
{ yyval.number = (yyvsp[-2].number < yyvsp[0].number); ;
    break;}
case 131:
#line 454 "kasm_parser.yy"
{ yyval.number = (yyvsp[-2].number >= yyvsp[0].number); ;
    break;}
case 132:
#line 455 "kasm_parser.yy"
{ yyval.number = (yyvsp[-2].number <= yyvsp[0].number); ;
    break;}
case 133:
#line 456 "kasm_parser.yy"
{ yyval.number = yyvsp[-2].number + yyvsp[0].number; ;
    break;}
case 134:
#line 457 "kasm_parser.yy"
{ yyval.number = yyvsp[-2].number - yyvsp[0].number; ;
    break;}
case 135:
#line 458 "kasm_parser.yy"
{ yyval.number = yyvsp[-2].number * yyvsp[0].number; ;
    break;}
case 136:
#line 459 "kasm_parser.yy"
{ yyval.number = (yyvsp[0].number != 0) ? yyvsp[-2].number / yyvsp[0].number : ~0; ;
    break;}
case 137:
#line 460 "kasm_parser.yy"
{ yyval.number = yyvsp[-2].number % yyvsp[0].number; ;
    break;}
case 138:
#line 461 "kasm_parser.yy"
{ yyval.number = yyvsp[-2].number << yyvsp[0].number; ;
    break;}
case 139:
#line 462 "kasm_parser.yy"
{ yyval.number = yyvsp[-2].number >> yyvsp[0].number; ;
    break;}
case 140:
#line 463 "kasm_parser.yy"
{ yyval.number = yyvsp[-1].number; ;
    break;}
case 141:
#line 466 "kasm_parser.yy"
{ yyval.number = yyvsp[0].number; ;
    break;}
case 142:
#line 467 "kasm_parser.yy"
{ yyval.number = strtol(yyvsp[0].str, NULL, 16); ;
    break;}
case 143:
#line 468 "kasm_parser.yy"
{
        Entry_Table_iter i = file_entries.find(yyvsp[0].str);
        if (i != file_entries.end()) {
                if (i->second->type() != T_POINTER) {
                        yyval.number = 0;
                        yyerror("Entry type not allowed here");
                } else
                        yyval.number = i->second->get_address();
        } else {
                i = global_entries.find(yyvsp[0].str);
                if (i != global_entries.end()) {
                        if (i->second->type() != T_POINTER) {
                                yyval.number = 0;
                        yyerror("Entry type not allowed here");
                        } else
                                yyval.number = i->second->get_address();
                } else {
                        if (!firstpass)
                                yyerror("Undefined label", true);
                        yyval.number = 0;
                }
        }
      
;
    break;}
case 144:
#line 492 "kasm_parser.yy"
{ yyval.number = pc; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 543 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;

 yyacceptlab:
  /* YYACCEPT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 0;

 yyabortlab:
  /* YYABORT comes here.  */
  if (yyfree_stacks)
    {
      free (yyss);
      free (yyvs);
#ifdef YYLSP_NEEDED
      free (yyls);
#endif
    }
  return 1;
}
#line 494 "kasm_parser.yy"
